%le(wts, s, iters)
function [output]=letest(iters)

%calculates LE for iters iterations
%Oguz Yetkin 11/24/1998
%for now,works for square matrices (because of all-connected simplification)

d0=0.000001;
d1=0;
%wts is an N by M array, outputs is a vector of size N
%n=size(wts); n=n(2);
n=32;
%m=size(wts);m=m(1);
%x=zeros(size(n));   %assuming all is square
%xe=zeros(size(n));
%y=x;		%just to initialize
%ye=xe;
gaussnum=32;

%init x to random, xe to x+d0

%commented out for testing
%x=rand(1,n);
%xe=x+d0;	%adds d0 to each element!!!

x=0.1;
y=0.1;
xe=x+d0;
ye=y+d0;

dsum=0;	%separation ?
lsum=0;
le=0;

%for testing
%get it on the attractor
%  for j=1:200
%    [x y]=henon(x,y,0.3,1.4,1);
    %[xe ye]=henon(xe,ye,0.3,1.4,1);
%  end
xe=x+d0;
ye=y+d0;

for i=1:iters
	%using henon data to test with n points
	
	%y=niterate(wts, x, s);
	%ye=niterate(wts, xe, s);
	%[x y]=henon(x(end),y(end),0.3,1.4,n);
	%[xe ye]=henon(xe(end),ye(end),0.3,1.4,n);

	
	[x y]=henon(x,y,0.3,1.4,1);
	[xe ye]=henon(xe,ye,0.3,1.4,1);

	dsum=0;
	for j=1:size(y)
		%dsum=dsum+(y(j)-ye(j)).^2;   %euclidean distance
		%analogous for testing	
		dsum=(x-xe).^2+(y-ye).^2;
	end
	d1=sqrt(dsum);
	for j=1:n              %Readjust ye for separation d0
               	%commented for testing 
		%ye(j)=y(j)+(d0/d1).*(ye(j)-y(j));
	end
	%for testing	
	xe=x+d0*(xe-x)/d1;
	ye=y+d0*(ye-y)/d1;


	lsum=lsum+log(abs(d1/d0));
	le=lsum./i;	%running average
end
	
output=le;

