%le(wts, s, iters)
function [output]=lyapunov(wts,s,iters)

%calculates LE for iters iterations
%Oguz Yetkin 11/24/1998
%for now,works for square matrices (because of all-connected simplification)

d0=0.000001;
d1=0;
%wts is an N by M array, outputs is a vector of size N
n=size(wts); n=n(2);
m=size(wts);m=m(1);
x=zeros(size(n));   %assuming all is square
xe=zeros(size(n));
gaussnum=32;

%init x to random, xe to x+d0
x=rand(1,n);
xe=x+d0;	%adds d0 to each element!!!
y=x;
ye=xe;


dsum=0;	%separation ?
lsum=0;
le=0;
for i=1:iters
	%added 12/11/1998	
	x=y;
	xe=ye;

	y=niterate(wts, x, s);
	ye=niterate(wts, xe, s);
	

	
	%[x y]=henon(x(end),y(end),0.3,1.4,n);
	%[xe ye]=henon(xe(end),ye(end),0.3,1.4,n);

	dsum=0;
	for j=1:size(y)
		%LEFT OFF COPYING
		dsum=dsum+(y(j)-ye(j)).^2;   %euclidean distance
	end
	d1=sqrt(dsum);
	for j=1:n              %Readjust ye for separation d0
                ye(j)=y(j)+(d0/d1).*(ye(j)-y(j));
	end
	lsum=lsum+log(abs(d1/d0));
	le=lsum./i;	%running average
end
	
output=le;

